// Options Screen

u8 options_curposY[] = {67, 81, 94};
u8 options_curposX[] = {37, 37, 37};

u8 options_curpos = 0;

bool options_exit;

#define max_bg 6

// IMPORTANT ONES //
s8 OPTIONS_BGCOLOR = 0;
u8 OPTIONS_SOUND = 1;
////////////////////

bool options_bClickD;
bool options_bClickA;

void Options_Show(void)
{
	ClearSprites();
	CopyOAM();
	copy2obj((u8*)gfx_options, (u16*)0x6003000, 160, 128, true );
	copy2obj((u8*)gfx_bgpick , (u16*)0x6010400, 40 , 112, false);
	copy2obj((u8*)gfx_sndpick, (u16*)0x60104A0, 32 , 32 , false);
	AddSprite_8x8(options_curposX[options_curpos] + 40, options_curposY[options_curpos] + 16, 1);
	AddSprite_32x16(68  + 40, 80 + 16, 32 + OPTIONS_BGCOLOR * 64);
	AddSprite_8x16 (100 + 40, 80 + 16, 36 + OPTIONS_BGCOLOR * 64);
	AddSprite_32x16(89  + 40, 66 + 16, 37 + OPTIONS_SOUND * 64  );
	options_bClickD = true;
	options_bClickA = true;
	options_exit = false;
	while(1)
	{
		Options_GetInput();
		CopyOAM();
		WaitForVSync();
		if (options_exit)
		{
			ClearSprites();
			CopyOAM();
			break;
		}
	}
}


void Options_GetInput(void)
{
	if (KeyState(KEY_UP) & !options_bClickD)
	{
		options_bClickD = true;
		if (options_curpos > 0)
		{
			options_curpos--;
			sprites[0].attribute0 = options_curposY[options_curpos] + 16;
			sprites[0].attribute1 = options_curposX[options_curpos] + 40;
			Snd_Stop();
			Snd_Beep(3, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
		}
	}
	if (KeyState(KEY_DOWN) & !options_bClickD)
	{
		options_bClickD = true;
		if (options_curpos < 2)
		{
			options_curpos++;
			sprites[0].attribute0 = options_curposY[options_curpos] + 16;
			sprites[0].attribute1 = options_curposX[options_curpos] + 40;
			Snd_Stop();
			Snd_Beep(3, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
		}
	}
	if (KeyState(KEY_LEFT) & !options_bClickD)
	{
		options_bClickD = true;
		if (options_curpos == 0)
		{
			
			OPTIONS_SOUND = !OPTIONS_SOUND;
			cur_sprite = 1;
			AddSprite_32x16(68  + 40, 80 + 16, 32 + OPTIONS_BGCOLOR * 64);
			AddSprite_8x16 (100 + 40, 80 + 16, 36 + OPTIONS_BGCOLOR * 64);
			AddSprite_32x16(89  + 40, 66 + 16, 37 + OPTIONS_SOUND * 64);
			SaveGame();
			Snd_Stop();
			Snd_Beep(4, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
		}
		else if (options_curpos == 1)
		{
			Snd_Stop();
			Snd_Beep(4, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
			OPTIONS_BGCOLOR--;
			if (OPTIONS_BGCOLOR < 0) OPTIONS_BGCOLOR = max_bg;
			SetBGColor(color_bg[OPTIONS_BGCOLOR]);
			cur_sprite = 1;
			AddSprite_32x16(68  + 40, 80 + 16, 32 + OPTIONS_BGCOLOR * 64);
			AddSprite_8x16 (100 + 40, 80 + 16, 36 + OPTIONS_BGCOLOR * 64);
			AddSprite_32x16(89  + 40, 66 + 16, 37 + OPTIONS_SOUND * 64);
			SaveGame();
		}
	}
	if (KeyState(KEY_RIGHT) & !options_bClickD)
	{
		options_bClickD = true;
		if (options_curpos == 0)
		{
			
			OPTIONS_SOUND = !OPTIONS_SOUND;
			cur_sprite = 1;
			AddSprite_32x16(68  + 40, 80 + 16, 32 + OPTIONS_BGCOLOR * 64);
			AddSprite_8x16 (100 + 40, 80 + 16, 36 + OPTIONS_BGCOLOR * 64);
			AddSprite_32x16(89  + 40, 66 + 16, 37 + OPTIONS_SOUND * 64);
			SaveGame();
			Snd_Stop();
			Snd_Beep(4, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
		}
		else if (options_curpos == 1)
		{
			Snd_Stop();
			Snd_Beep(4, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
			OPTIONS_BGCOLOR++;
			if (OPTIONS_BGCOLOR > max_bg) OPTIONS_BGCOLOR = 0;
			SetBGColor(color_bg[OPTIONS_BGCOLOR]);
			cur_sprite = 1;
			AddSprite_32x16(68  + 40, 80 + 16, 32 + OPTIONS_BGCOLOR * 64);
			AddSprite_8x16 (100 + 40, 80 + 16, 36 + OPTIONS_BGCOLOR * 64);
			AddSprite_32x16(89  + 40, 66 + 16, 37 + OPTIONS_SOUND * 64);
			SaveGame();
		}
	}
	if (KeyState(KEY_A) & !options_bClickA)
	{
		options_bClickA = true;
		if (options_curpos == 0)
		{
			OPTIONS_SOUND = !OPTIONS_SOUND;
			cur_sprite = 1;
			AddSprite_32x16(68  + 40, 80 + 16, 32 + OPTIONS_BGCOLOR * 64);
			AddSprite_8x16 (100 + 40, 80 + 16, 36 + OPTIONS_BGCOLOR * 64);
			AddSprite_32x16(89  + 40, 66 + 16, 37 + OPTIONS_SOUND * 64);
			SaveGame();
			Snd_Stop();
			Snd_Beep(4, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
		}
		else if (options_curpos == 1)
		{
			Snd_Stop();
			Snd_Beep(4, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
			OPTIONS_BGCOLOR++;
			if (OPTIONS_BGCOLOR > max_bg) OPTIONS_BGCOLOR = 0;
			SetBGColor(color_bg[OPTIONS_BGCOLOR]);
			cur_sprite = 1;
			AddSprite_32x16(68  + 40, 80 + 16, 32 + OPTIONS_BGCOLOR * 64);
			AddSprite_8x16 (100 + 40, 80 + 16, 36 + OPTIONS_BGCOLOR * 64);
			AddSprite_32x16(89  + 40, 66 + 16, 37 + OPTIONS_SOUND * 64);
			SaveGame();
		}
		else if (options_curpos == 2)
		{
			options_exit = true;
			Snd_Stop();
			Snd_Beep(5, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
		}
	}
	if (!KeyState(KEY_UP) & !KeyState(KEY_RIGHT) & !KeyState(KEY_DOWN) & !KeyState(KEY_LEFT)) options_bClickD = false;
	if (!KeyState(KEY_A)) options_bClickA = false;
}
